
#!/bin/bash

#INTERFACES=`netstat -i | grep -E '(BMRU)|(BOPRU)' | grep -v 'no statistics available' | grep -Eo '^[^ ]+' | paste -d " " - - - - - - - - - - - -`
INTERFACES=`ip -o link show | grep ether | awk '{print $2}' | sed s/:// | paste -d " " - - - - - - - - - - - -`

declare -a arr=($INTERFACES)
declare -a OCTETOSRX=()
declare -a OCTETOSTX=()

for i in "${arr[@]}"
do   
   if [ -f /sys/class/net/${i}/statistics/rx_bytes ]; then
	RX=`cat /sys/class/net/${i}/statistics/rx_bytes`
   	TX=`cat /sys/class/net/${i}/statistics/tx_bytes`
   else
	RX=0
	TX=0
   fi
   if [ -z "$RX" ]; then
	RX=0
   fi
   if [ -z "$TX" ]; then
	TX=0
   fi   
   #echo "Obtendo dado inicial para a interface $i $RX $TX..."   
   OCTETOSRX+=("$RX")
   OCTETOSTX+=("$TX")
done

#echo "Obtendo dado de cpu inicial..."
read cpu a b c previdle rest < /proc/stat
prevtotal=$((a+b+c+previdle))  
sleep 1
#echo "Obtendo dado de cpu final..."
read cpu a b c idle rest < /proc/stat
total=$((a+b+c+idle))

#echo "Obtendo quantidade de cpus..."
CPUQTT=`nproc`

CPU=$((100*( (total-prevtotal) - (idle-previdle) ) / (total-prevtotal) ))

#DISCOARRTMP=`df | tail -n +2`
#declare -a DISCOARR=()
#while read -r line; do
#    declare -a campos=($line)
#    DISCOARR+=("{\"name\": \"${campos[0]}\", \"total\": ${campos[1]},\"used\": ${campos[2]} }")
#done <<< "${DISCOARRTMP}"

echo -ne "{\"interfaces\":["
let QTTOCTETS=${#OCTETOSRX[@]}-1
for (( i = 0 ; i < ${#OCTETOSRX[@]} ; i=$i+1 ));
    do
		echo -ne "{\"name\": \"${arr[${i}]}\", \"rx\": ${OCTETOSRX[${i}]}, \"tx\": ${OCTETOSTX[${i}]} }"
		if [ "$i" -lt "$QTTOCTETS" ]; then
			echo -ne ","
		fi
    done
echo -ne "],"

#echo -ne "\"discos\":["
#let QTTDISCOS=${#DISCOARR[@]}-1
#for (( i = 0 ; i < ${#DISCOARR[@]} ; i=$i+1 ));
#    do
#		echo -ne "$DISCOARR"
#		if [ "$i" -lt "$QTTDISCOS" ]; then
#			echo -ne ","
#		fi
#    done
#echo -ne "],"

echo -ne "\"services\": \""
array=('chk=("tvbus-station" "so:")' 'chk=("tvbus .*-C" "sc:")' 'chk=("tvbus .*-K" "mk:")' 'chk=("node bin/admin.js" "adm:")' 'chk=("./rboker$" "brk:")' 'chk=("ffmpeg" "stm:")' 'chk=("iperf3" "test:")' 'chk=("./proxy$" "pxy:")')

for elt in "${array[@]}"
   do
      eval $elt
      #echo ${chk[0]} ${chk[1]} ${chk[2]}
      procCnt=`ps ax | grep "${chk[0]}" | grep -v grep | wc -l`
      if [ $procCnt -gt 0 ]; then
         echo -ne "${chk[1]}$procCnt "
      fi
done
echo -ne "\", "

echo -ne "\"processor\": {\"load\": $CPU, \"processors\": $CPUQTT },"

MEMORIATMP=`free -b | head -n 2 | tail -n 1`
declare -a MEMORIA=($MEMORIATMP)
if free -b | head -1 | grep -q available
then
      echo -ne "\"memoria\": { \"total\": ${MEMORIA[1]}, \"free\": ${MEMORIA[6]}}"
else
      echo -ne "\"memoria\": { \"total\": ${MEMORIA[1]}, \"free\": $((${MEMORIA[3]}+${MEMORIA[5]}+${MEMORIA[6]}))}"
fi

echo "}"



