#!/usr/bin/dumb-init /bin/sh

LOGFILE=./var/logs/p2p.log
service nscd restart >> $LOGFILE 2>&1 &

#monitor p2p
checkp2p()
{
    date=`date +%Y-%m-%d\ %H:%M:%S`
    if ps xa | grep '\./p2p$' | grep -v grep
    then
        echo "$date [etime:$1] p2p is working now ..." | tee -a $LOGFILE
    else
        echo "$date starting p2p ..." | tee -a $LOGFILE
        exec ./p2p >> $LOGFILE 2>&1 &
    fi
}
#check log size
cleanlog()
{
    if [ `stat -c%s $LOGFILE` -gt 10000000 ] ; then
        echo "cleaning log..." | tee -a $LOGFILE
        cat /dev/null > $LOGFILE
    fi
    find var/logs/ -type f -name "so_*" -mtime +2 | xargs rm -rf
}

cnt=0
restart_cnt=172800
interval=5
cleanlog
while /bin/true
do
    cnt=$((cnt+1))
    if [ "$cnt" -gt "$restart_cnt" ] ; then
        kill `ps ax | grep "./p2p$" | grep -v grep | awk '{print $1}'`
        cleanlog
        cnt=0
    fi
    checkp2p $(($interval*$cnt))
    sleep $interval
done
